﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Collections;
using System.IO;
using System.Text.RegularExpressions;
using System.Web;
using NicovideoUtil;
using Codeplex.Data;
using System.Threading.Tasks;
using System.Threading;


namespace Mikumiku
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();

        }

        /// <summary>
        /// 動画をダウンロードする
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            button1.Enabled = false;
            VideoItem[] mylist = null;
            //マイリストをダウンロード
            if(radioButton2.Checked){
                mylist = getTagList("http://ext.nicovideo.jp/api/search/tag/" + listText.Text + "?mode=watch&order=d&sort=n", Nicovideo.LoginCookie);
            }
            else if (radioButton1.Checked)
            {
                mylist = getMylist("http://www.nicovideo.jp/api/mylist/list?group_id="+listText.Text, Nicovideo.LoginCookie);
            }
            else
            {
                MessageBox.Show("エラーです");
            }
            
            //FLVファイルをダウンロード
            toolStripStatusLabel1.Text = "ダウンロード開始";
            BackgroundWorker bw = new BackgroundWorker();
            bw.DoWork += delegate(object s, DoWorkEventArgs ev)
            {


                foreach (var id in mylist)
                {
                    bw.ReportProgress(0, id.VideoId + "のダウンロード開始");
                    WebClient client = null;
                    try
                    {
                        if (File.Exists(getFileExtention(id.VideoId))) continue;
                        Console.WriteLine(id.VideoId + "ダウンロード開始");
                        var flvinfo = FlvInfo.Create(id.VideoId);
                        // Thread.Sleep(5000);
                        client = Nicovideo.GetWebClientForFlv(id.VideoId);
                        Console.WriteLine("動画の情報取得完了");
                        // System.Threading.Thread.Sleep(1000 * 5);
                        //  toolStripStatusLabel1.Text = id.VideoId + "をダウンロード中です";
                        client.DownloadFile(flvinfo.FlvUrl, getFileExtention(id.VideoId));

                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine(id.VideoId + "のダウンロード中二エラーが発生しました。" + ex.ToString());
                        bw.ReportProgress(0, id.VideoId + "のダウンロード中二エラーが発生しました。");
                        continue;
                    }
                    finally
                    {
                        if (client != null) client.Dispose();
                    }
                    bw.ReportProgress(0,id.VideoId+"のダウンロード完了");


                }
            };
            bw.ProgressChanged += delegate(object s1, ProgressChangedEventArgs ev1) { toolStripStatusLabel1.Text = (string)ev1.UserState; };
            bw.WorkerReportsProgress = true;
            bw.RunWorkerCompleted += delegate(object s, RunWorkerCompletedEventArgs ev) { toolStripStatusLabel1.Text = "動画ダウンロード完了！"; button1.Enabled = true; };
            bw.RunWorkerAsync();

        }

        /// <summary>
        /// IDがsmで始まるならflvに、nmで始まるならswfにする
        /// </summary>
        public string getFileExtention(string id)
        {
            if (id.Contains("nm"))
            {
                return id + "swf";
            }
            else
            {
                return id + "flv";
            }
        }
        /// <summary>
        /// 使ってない
        /// </summary>
        public void Logout()
        {
            var req = (HttpWebRequest)HttpWebRequest.Create("https://secure.nicovideo.jp/secure/logout");
            req.CookieContainer = Nicovideo.LoginCookie;
            req.Timeout = 5000;
            req.UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows XP)";

            HttpWebResponse resp;
            try
            {
                resp = (HttpWebResponse)req.GetResponse();
            }
            catch (Exception ex)
            {

                throw new Exception("Error while retrieving watch cookie.", ex);
            }

            return;
        }


        /// <summary>
        /// ID3タグの情報を取得するためにmikuwikiから引っ張ってくる
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button3_Click(object sender, EventArgs e)
        {
            StringBuilder sb = new StringBuilder();
            MyListView listView;

            //マイリストをダウンロード
            VideoItem[] mylist = null;
            //マイリストをダウンロード
            if (radioButton2.Checked)
            {
                mylist = getTagList("http://ext.nicovideo.jp/api/search/tag/" + listText.Text + "?mode=watch&order=d&sort=n", Nicovideo.LoginCookie);
            }
            else if (radioButton1.Checked)
            {
                mylist = getMylist("http://www.nicovideo.jp/api/mylist/list?group_id=" + listText.Text, Nicovideo.LoginCookie);
            }
            else
            {
                MessageBox.Show("エラーです");
            }
            foreach (var id in mylist)
            {
                List<MikuDB> miku = getMikuWiki(id.VideoId, id.Title);
                if (miku.Count >= 2)
                {
                    listView = new MyListView()
                    {
                        GridLines = true,     // グリッド線を表示
                        View = View.Details,  // 詳細ビュー
                        Dock = DockStyle.Fill,
                    };
                    listView.AddMiku(miku);
                    Form f = new Form();
                    f.Text = id.Title + "(" + id.Id + ")" + "の正しい情報選んで✕ボタンを押す";
                    Button b = new Button()
                    {
                        Text = "OK",
                        Location = new Point(0, 0),
                    };
                    b.Click += ((se, ev) => { f.Close(); });
                    f.Controls.Add(b);
                    f.Controls.Add(listView);
                    f.ShowDialog();
                    Console.WriteLine("選択されたもの" + miku[listView.SelectedItems[0].Index]);
                    sb.Append(miku[listView.SelectedItems[0].Index].ToString() + "\n");
                }
                else
                {
                    sb.Append(miku[0].ToString() + "\n");
                }
            }
            System.IO.StreamWriter sw = new System.IO.StreamWriter(
                @"./mp3list.txt",
                false,
                System.Text.Encoding.GetEncoding("shift_jis"));
            //TextBox1.Textの内容を書き込む
            sw.Write(sb.ToString());
            //閉じる
            sw.Close();

        }

        //タグ検索で動画一覧を取得
        private VideoItem[] getTagList(String url, CookieContainer cc)
        {
            List<VideoItem> list = new List<VideoItem>();
            int count = 1; 
            while (true)
            {
                try
                {
                    string str = getHttp(url + "&page=" + count, cc);
                    var json = DynamicJson.Parse(str);
                    foreach (var id in json.list)
                    {
                        var item = new VideoItem();
                        item.VideoId = id.id;
                        item.Title = id.title;
                        item.Id = id.id;
                        item.ThumbUrl = id.thumbnail_url;
                        list.Add(item);
                        if (list.Count >= json.count) return list.ToArray<VideoItem>();
                    }

                    count++;

                    Thread.Sleep(1000);
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.ToString());
                    Thread.Sleep(1000 * 10);
                }


            }
            return list.ToArray<VideoItem>();
        }
        /// <summary>
        /// マイリストを取得
        /// </summary>
        /// <param name="url"></param>
        /// <param name="cc"></param>
        /// <returns></returns>
        private VideoItem[] getMylist(string url, CookieContainer cc)
        {
            List<VideoItem> list = new List<VideoItem>();
            string str = getHttp(url, cc);
            var json = DynamicJson.Parse(str);
            foreach (var id in json.mylistitem)
            {
                var item = new VideoItem();
                item.VideoId = id.item_data.video_id;
                item.Title = id.item_data.title;
                item.Id = id.item_id;
                item.ThumbUrl = id.item_data.thumbnail_url;
                list.Add(item);
            }
            return list.ToArray<VideoItem>();
        }
        /// <summary>
        /// 同期通信する
        /// </summary>
        /// <param name="url"></param>
        /// <param name="cc"></param>
        /// <returns></returns>
        public string getHttp(string url, CookieContainer cc)
        {
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(new Uri(url));
            req.CookieContainer = cc;
            WebResponse rsp;
            try
            {
               rsp  = req.GetResponse();
            }
            catch (Exception e)
            {
                Console.WriteLine("HTTPの通信に失敗しました。10秒待機します");
                Thread.Sleep(1000 * 10);
                return getHttp(url, cc);
            }
            Stream stm = rsp.GetResponseStream();
            string str = "";
            if (stm != null)
            {
                StreamReader reader = new StreamReader(stm, System.Text.Encoding.GetEncoding("UTF-8"));
                str = reader.ReadToEnd();
                stm.Close();
            }

            rsp.Close();
            req.Abort();

            return str;
        }
        public List<MikuDB> getMikuWiki(string id, string title)
        {
            Console.WriteLine(id + "を検索します");

            
            //検索する
            string search = getHttp("http://www5.atwiki.jp/hmiku/?cmd=search&keyword=" + id, new CookieContainer());
            System.Text.RegularExpressions.Regex r = new System.Text.RegularExpressions.Regex("<a href=\"(?<url>.*?)\".*?>(?<text>.*?)/a>",
                 System.Text.RegularExpressions.RegexOptions.IgnoreCase
                | System.Text.RegularExpressions.RegexOptions.Singleline);

            //正規表現と一致する対象をすべて検索
            System.Text.RegularExpressions.MatchCollection mc = r.Matches(search);
            List<String> next = new List<String>();
            foreach (System.Text.RegularExpressions.Match m in mc)
            {
                if (m.Value.Contains("word=" + id))
                {
                    next.Add(m.Groups[1].Value);

                }
            }
            List<MikuDB> mikuList = new List<MikuDB>();
            foreach (var url in next)
            {
                var miku = new MikuDB();
                miku.Id = id;
                miku.Title = title;
                string unEscapeUri = Uri.UnescapeDataString(url.Replace("&amp;", "&"));
                Console.WriteLine(unEscapeUri);
                string wiki = getHttp(unEscapeUri, new CookieContainer());
                
                r = new Regex("作曲：(?<name>.+)", RegexOptions.IgnoreCase);
                var rep = r.Match(wiki).Groups[1].Value;
                if (rep != "")//作曲者が書いてあったら正しいページと判断
                {
                    miku.MusicBy = Regex.Replace(rep, "<([^>]|\n)*>", "");//タグを取る
                }else {
                    //なかったら次へ
                    continue;
                }
                r = new Regex("作詞：(?<name>.+)", RegexOptions.IgnoreCase);
                rep = r.Match(wiki).Groups[1].Value;
                if (rep != "") miku.LyricBy = Regex.Replace(rep, "<([^>]|\n)*>", "");//タグを取る

                r = new Regex("編曲：(?<name>.+)", RegexOptions.IgnoreCase);
                rep = r.Match(wiki).Groups[1].Value;
                if (rep != "") miku.ComposeBy = Regex.Replace(rep, "<([^>]|\n)*>", "");//タグを取る

                r = new Regex("唄：(?<name>.+)", RegexOptions.IgnoreCase);
                rep = r.Match(wiki).Groups[1].Value;
                if (rep != "") miku.Vocal = Regex.Replace(rep, "<([^>]|\n)*>", "");//タグを取る

                r = new Regex("<title>(?<title>.+)</title>", RegexOptions.IgnoreCase | RegexOptions.Singleline);
                rep = r.Match(wiki).Groups[1].Value;
                miku.Title = rep.Replace("初音ミク Wiki - ", "");

                r = new Regex(">歌詞</h3>(?<name>.+?)<h3", RegexOptions.IgnoreCase | RegexOptions.Singleline);
                rep = r.Match(wiki).Groups[1].Value;
                rep = Regex.Replace(rep, "<br />", "@*BR*@");//改行だけ残す
                rep = Regex.Replace(rep, "<([^>]|\n)*>", "");//タグを取る
                rep = rep.Replace("\n", "");//改行を置換
                rep = rep.Replace("\n", "");//改行を置換
                miku.Lyric = rep.Replace("@*BR*@", "<BR>");//改行を置換
                miku.VideoTitle = title;//動画のタイトル
                mikuList.Add(miku);
                
            }
            if (mikuList.Count == 0)
            {
                MikuDB m = new MikuDB();
                m.Id = id;
                m.VideoTitle = title;
                m.Title = title;
                mikuList.Add(m);
            }
            
            return mikuList;
        }
        public class MikuDB
        {
            /// <summary>
            /// 曲のタイトル
            /// </summary>
            public string Title { get; set; }
            /// <summary>
            /// 動画に付けられたタイトル
            /// </summary>
            public string VideoTitle { get; set; }
            /// <summary>
            /// 動画のID
            /// </summary>
            public string Id { get; set; }
            /// <summary>
            /// 作詞
            /// </summary>
            public string LyricBy { get; set; }
            /// <summary>
            /// 作曲
            /// </summary>
            public string MusicBy { get; set; }
            /// <summary>
            /// 編曲
            /// </summary>
            public string ComposeBy { get; set; }
            /// <summary>
            /// うた
            /// </summary>
            public string Vocal { get; set; }
            /// <summary>
            /// 歌詞
            /// </summary>
            public string Lyric { get; set; }
            public override string ToString()
            {
                return Id +","+ Title + "," +VideoTitle+","+ MusicBy +","+ LyricBy +"," +ComposeBy+","+ Vocal +","+Lyric;
            }

        }
        public class VideoItem
        {
            public string VideoId { get; set; }
            public string Id { get; set; }
            public string ThumbUrl { get; set; }
            public string Title { get; set; }
        }
        // ファイルリスト用のリストビュー
        class MyListView : ListView
        {
            ColumnHeader index;  // 'ファイル名' 列ヘッダ
            ColumnHeader title;  // 'ファイル名' 列ヘッダ
            ColumnHeader music;  // 'ファイルパス' 列ヘッダ
            ColumnHeader lyric;  // 'ファイルパス' 列ヘッダ
            ColumnHeader compose;  // 'ファイルパス' 列ヘッダ

            public MyListView()
            {
                this.FullRowSelect = true;
                index = new ColumnHeader() { Text = "選択" };
                title = new ColumnHeader() { Text = "曲名" };
                music = new ColumnHeader() { Text = "作曲" };
                lyric = new ColumnHeader() { Text = "作詞" };
                compose = new ColumnHeader() { Text = "編曲" };

                // 2 つの列ヘッダをリストに追加
                this.Columns.AddRange(new ColumnHeader[]
        {
            index,title, music, lyric, compose
        });
            }
            public void AddMiku(List<MikuDB> db)
            {
                int i = 0;
                foreach (MikuDB miku in db)
                {
                    // リスト項目を追加
                    this.Items.Add(new ListViewItem(
                        new string[] { i+"", miku.Title , miku.MusicBy, miku.LyricBy,miku.ComposeBy }));
                    i++;
                }
            }
        }

        /// <summary>
        /// ログインを行う
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button4_Click(object sender, EventArgs e)
        {
            try
            {
                toolStripStatusLabel1.Text = "ログイン通信中・・・";
                BackgroundWorker bw = new BackgroundWorker();
                bw.DoWork += delegate(object s, DoWorkEventArgs ev) { NicovideoUtil.Nicovideo.LoginToNicovideo(idText.Text, passText.Text); };
                bw.RunWorkerCompleted += delegate(object s, RunWorkerCompletedEventArgs ev) { toolStripStatusLabel1.Text = "ログイン完了"; };
                bw.RunWorkerAsync();
                              

            }
            catch (Exception ex)
            {
                Console.WriteLine("ログイン中二エラーが発生しました。" + ex.ToString());
                MessageBox.Show("エラーが発生しました、終了します");
                Environment.Exit(0);
            }
        }

        /// <summary>
        /// 入力したマイリストのサムネイルをダウンロードする
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = "サムネイルダウンロード開始";
            //マイリストをダウンロード
            VideoItem[] mylist = null;
            //マイリストをダウンロード
            if (radioButton2.Checked)
            {
                mylist = getTagList("http://ext.nicovideo.jp/api/search/tag/" + listText.Text + "?mode=watch&order=d&sort=n", Nicovideo.LoginCookie);
            }
            else if (radioButton1.Checked)
            {
                mylist = getMylist("http://www.nicovideo.jp/api/mylist/list?group_id=" + listText.Text, Nicovideo.LoginCookie);
            }
            else
            {
                MessageBox.Show("エラーです");
            }
            foreach (var id in mylist)
            {
                if (File.Exists(id.VideoId + ".jpg")) continue;
                System.Net.WebClient wc = new System.Net.WebClient();
                wc.DownloadFile(id.ThumbUrl, id.VideoId+".jpg");
                wc.Dispose();
            }
            toolStripStatusLabel1.Text = "サムネイルダウンロード完了！";

        }

    }
}

